 ! Fileio - Copyright February 2006 By Gabriel Bakker #Autonumber# 10,10
 !    Distributed Open Source As A Christmas Gift To Brag Members
 ! This Library Houses All File Maintenance Operations
 !
 ! Created: 03/28/06
 ! Modified: 09/21/09
 !
 !
 ! #Autonumber# 500,1
 ! If You Run This Library As A Program, It Will Function As A Data
 ! Crawler That Will Allow You To View The Raw Data In Your Datafiles
 !
 ! To Update A Datafile, Just Simply Increase The Version Number
 ! Then Make Any Change You Like - Add Fields, Remove Fields, Rearrange
 ! Fields, Change Keys...
 !
 ! Then Just Run Your Software Normally - Upon First Time, Version
 ! Discrepancy Is Detected, And File Is Updated Dynamically.
 !
 ! Note: Do Not Change Your Subscript Names Between Versions.
 ! They Can Be Rearranged, And You Can Insert New Data, But The Fileio
 ! Library Uses The Subscript Names To Ensure The Proper Data Is Placed
 ! In The Correct Spot In The New Version Of The Data File During The
 ! Update.
 !
 ! Global Settings Such As The Default File Layout Path May Be Set
 ! By Typing 'LIST SETTINGS' And Scrolling Down A Few Lines.
 ! Simply Changing The Related Line Will Update The Global Default
 !
    goto DIMS
 !
 ! #Autonumber# 1000,10
 SETTINGS: ! ***** Set Global Defaults For The Library Here
    def Fnsettings(&Defaultfilelayoutpath$;&Promptonfilecreate,&Createlogfile,&EnforceDupkeys,&StartFileNumber,&CheckIndex,&CompressColumns,&MaxColWidth)
       let EnforceDupkeys=1  ! Enforce that key number 1 is unique key
       let Defaultfilelayoutpath$="filelay\" ! Path To Your File Layouts
       let Promptonfilecreate=1 ! Ask User Before Creating New Files
       let Createlogfile=0
       let StartFileNumber=1
       let CheckIndex=0 ! Automatically Update Indexes (Use for partial fileio implementations, disable for full fileio installations.)
       let CompressColumns=0 ! Shrink or Expand Columns in Data Crawler by Default
       let MaxColWidth=20 ! Max Default Column Width in Data Crawler
    fnend
 !
 ! #Autonumber# 2000,10
 DIMS: ! Dimension Statements For Data Crawler
    dim Lvdir_Headings$(1)*30,Lvdir_Widths(1),Lvdir_Fieldforms$(1)
    dim Dc_Data$(1)*1024,Dc_Data(1),Dc_Forms$(1)*2000,Dc_Dfdescr$(1)*80
    dim Dc_Widths(1),Dc_Fieldforms$(1),Dc_Outputrow$(1)*1024
    dim De_Data$(1)*1024,De_Data(1),De_Dfdescr$(1)*80
    dim De_Widths(1),De_Fieldforms$(1),De_Outputrow$(1)*1024,De_Records(1)
    dim De_Savedata$(1)*1024, De_Savesubs(1)
    dim De_Deleterow(1),De_Colorstart(1),De_Colorend(1),De_Color$(1)
    dim De_Changeddata$(1)*1024, De_Changedsubs(1)
 !
    if Trim$(Env$("guimode"))="" then
       print "DataCrawler Mode only works with New Gui version of BR"
       stop
    end if
    let Turnguibackoff=(Env$("guimode")=="OFF")
    if Turnguibackoff then execute "config gui on"
 !
    let Lvdir_Headings$(1)="File Layouts" !:
    let Lvdir_Widths(1)=38 !:
    let Lvdir_Fieldforms$(1)="CC 30"

    library : Fnreadlayouts,Fndatacrawler,Fndataedit, fnGetFileNumber
 !
 SELECTDATAFILE: ! ***** Datafile Selection Routine #Autonumber# 7000,10

 !   open #(Dc_Window:=Fngetfilenumber): "srow=4,scol=22,rows=18,cols=39,Caption= Select File ... ENTER - View / F5 - Edit ,Border=S",display,outin
    open #(Dc_Window:=Fngetfilenumber): "srow=5,scol=22,rows=17,cols=39,Caption= Select File ... ENTER - View / F5 - Edit ,Border=S",display,outin
    let Fnreadlayouts(Mat Lvdir_Listing$)
    if Udim(Mat Lvdir_Listing$)>15 then let Lvdir_Widths(1)-=2 ! Make Room For Scrollbar
    print #Dc_Window, fields "17,3,CC 14,,B43;17,23,CC 14,,B44" : "Quit","View"
 !   print #Dc_Window, fields "18,10,CC 20,,B45" : "Generate Code"
    print #Dc_Window, fields "1,2,LIST 15/37,HEADERS" : (Mat Lvdir_Headings$, Mat Lvdir_Widths, Mat Lvdir_Fieldforms$)
    print #Dc_Window, fields "1,2,LIST 15/37,=" : (Mat Lvdir_Listing$)
    do
       input #Dc_Window, fields "1,2,LIST 15/37,ROWSUB,SELONE,44" : Chosen
       let Dc_Key=Fkey
       if Dc_Key=0 Or Dc_Key=201 then let Dc_Key=44 ! Ok Button
       if Dc_Key=99 then let Dc_Key=43 ! Esc Button
       if Dc_Key=93 then let Dc_Key=43
       if Dc_Key=44 then ! Ok Selected
          let Fndatacrawler(Lvdir_Listing$(Chosen))
       end if
       if Dc_Key=5 then
          let Fndataedit(Lvdir_Listing$(Chosen))
       end if
       if Dc_Key=45 then
          let fnGenerateCode(Lvdir_listing$(Chosen))
       end if
    loop Until Dc_Key=43
    close #Dc_Window:
 !
 ENDDATACRAWLER: ! #Autonumber# 8000,10
    if Turnguibackoff then execute "config gui off"
    if fkey=93 then
       execute "system"
    end if
    stop
 !
 ! #Autonumber# 10000,10
 DATACRAWLER: ! ***** Display A Listview Containing Raw File Data
    def library Fndatacrawler(Filelay$;srow$,scol$,rows$,cols$,___,Window,Selectedrow,Index,Or_Recordlocation,X$,Key,Key$,Clearflag$*1,Somethingfound)
       library : Fngetfilenumber, fnOpenFile
       let fnvalidatenonguirowcol(srow$,scol$,rows$,cols$)
       open #(Window:=Fngetfilenumber) : "sRow="&srow$&",sCol="&scol$&",Rows="&rows$&",Cols="&cols$&",Caption= View '"&Filelay$&"' File ... F4 to Search ,Border=S",display,outin
       let Dc_Datafile=Fnopen(Filelay$,Mat Dc_Data$,Mat Dc_Data,Mat Dc_Forms$,1,1,0,"",Mat Dc_Dfdescr$,Mat Dc_Widths)
       let fnReadPositions(Filelay$,mat Dc_DfDescr$)
       if Dc_Datafile then
          let Fncalculatefieldforms(Mat Dc_Fieldforms$,Mat Dc_Widths,Mat Dc_Dfdescr$)
          print #Window, fields Rows$&","&str$(val(cols$)-10)&",CC 10,,B54" : "Quit"
          print #Window, fields "1,1,LIST "&str$(val(rows$)-1)&"/"&cols$&",HEADERS" : (Mat Dc_Dfdescr$,Mat Dc_Widths,Mat Dc_Fieldforms$)
          do
             mat Dc_Outputrow$(0) : let Somethingfound=0
             let Clearflag$="="
             if Trim$(Key$)="" then !:
                restore #Dc_Datafile: !:
             else !:
                restore #Dc_Datafile, search>=Trim$(Key$): nokey CLEARENTERED
             do
    READNEXTDATAROW: ! Read The Next Row Here
                read #Dc_Datafile, using Dc_Forms$(Dc_Datafile) : Mat Dc_Data$,Mat Dc_Data error Ignore
                if File(Dc_DataFile)=10 then goto DONEREADINGDATAFILE
                let Somethingfound=1
                let Or_Recordlocation=Udim(Mat Dc_Outputrow$)
                mat Dc_Outputrow$(Udim(Dc_Outputrow$)+Udim(Mat Dc_Widths)) ! Add Room
                if Udim(Mat Dc_Data$) then ! Copy Strings !:
                   mat Dc_Outputrow$(Or_Recordlocation+1:Or_Recordlocation+Udim(Mat Dc_Data$))=Dc_Data$
                for Index=1 to Udim(Mat Dc_Data) ! Copy Numerics
                   let Dc_Outputrow$(Or_Recordlocation+Index+Udim(Mat Dc_Data$))=Str$(Dc_Data(Index))
                next Index
                if ((X$:=Unhex$(Kstat$))="6300") then goto DONEREADINGDATAFILE
                if Udim(Mat Dc_Outputrow$)+Udim(Mat Dc_Widths)>1000 then goto DONEREADINGDATAFILE
                goto READNEXTDATAROW
    DONEREADINGDATAFILE: ! Whole File Is Populated
                print #Window, fields "1,1,LIST "&str$(val(rows$)-1)&"/"&cols$&","&Clearflag$ : Mat Dc_Outputrow$
                mat Dc_Outputrow$(0) ! Clear Already Used Data To Go Back For More
                let Clearflag$="+"
             loop Until File(Dc_Datafile)=10 Or X$="6300" ! Until Eof Or Abort
             do
                if Somethingfound then !:
                   input #Window, fields "1,1,LIST "&str$(val(rows$)-1)&"/"&cols$&",ROWSUB,SELONE" : Selectedrow !:
                   let Key=Fkey !:
                else !:
                   let Msgbox("Data File is Empty") !:
                   let Key=99 ! Force Exit
             loop Until Key=99 Or Key=4 or Key=54 ! F4 Changes Settings
             if Key=4 then let Key$=Fninputkey$(Kln(Dc_Datafile))
          loop Until Key=99 or Key=54
          close #Dc_Datafile:
       end if
       close #Window:
    fnend
 CLEARENTERED: ! Invalid Key Entered
    let Msgbox("Key Not Found")
    let Key$=""
    retry
 !
 ! #Autonumber# 11000,10
 CALCULATEFIELDFORMS: ! ***** Calculate Field Forms From Widths And Num Of Strings/Numerics
    def Fncalculatefieldforms(Mat Fieldforms$,Mat Widths,Mat Description$;___,Index,D$*255,D1,D2,D3,D4,D5,CompressColumns,MaxColWidth)
       let fnSettings(D$,D1,D2,D3,D4,D5,CompressColumns,MaxColWidth)
       mat Fieldforms$(Udim(Mat Widths))
       for Index=1 to Udim(Mat Fieldforms$)
          let Fieldforms$(Index)="C "&Str$(Widths(Index))
          if ~CompressColumns then
             let Widths(Index)=Max(Widths(Index),Len(Description$(Index)))
          end if
          let Widths(Index)=Min(Widths(Index),MaxColWidth)
       next Index
    fnend

    dim SS$(1)*255,NS$(1)*255,SF$(1),NF$(1),SD$(1)*255,ND$(1)*255,SPosition(1),NPosition(1)
 ReadPositions: ! ***** Reads the positions and appends them to the descriptions array
    def fnReadPositions(Layout$,mat Description$;___,PF$,Index,Count)
       library : fnReadLayoutArrays
       let fnReadLayoutArrays(Layout$,PF$,mat SS$,mat NS$,mat SF$,mat NF$,mat SD$,mat ND$,mat SPosition,mat NPosition)
       
       for Index=1 to udim(mat SPosition)
          let Count+=1
          if Count<=udim(mat Description$) then let Description$(Count)=str$(SPosition(Index))&" - "&Description$(Count)
       next Index
       for Index=1 to udim(mat NPosition)
          let Count+=1
          if Count<=udim(mat Description$) then let Description$(Count)=str$(NPosition(Index))&" - "&Description$(Count)
       next Index
    fnend

 !
 ! #Autonumber# 13000,10
 INPUTKEY: ! ***** Prompts The User For The Key To Look Up In The Datafile
    def Fninputkey$*255(Length;Window,Field$,Newkey$*255,Key)
       open #(Window:=Fngetfilenumber) : "srow=12,scol="&Str$(40-Int(Max(Min(Length,78),15)/2))&",rows=1,cols="&Str$(Max(Min(Length,78),15))&",Caption= Enter New Key ,Border=S",display,output
       if Length>78 then !:
          let Field$="1,1,78/C "&Str$(Length) !:
       else !:
          let Field$="1,1,C "&Str$(Length)
       input #Window, fields Field$ : Newkey$
       close #Window:
       let Fninputkey$=Newkey$
    fnend
 !
 ! #Autonumber# 13500,10
 UPDATECOLORS: ! ***** Update Listview Colors
    mat De_Colorstart(0) !:
    mat De_Colorend(0) !:
    mat De_Color$(0) ! Clear Color Markings
    for Deleteindex=1 to Udim(Mat De_Deleterow)
       if De_Deleterow(Deleteindex) then ! If Row Is Marked For Deletion, Show It In Red
          mat De_Colorstart(Udim(Mat De_Colorstart)+1) !:
          mat De_Colorend(Udim(Mat De_Colorstart)) !:
          mat De_Color$(Udim(Mat De_Colorstart)) ! Make Room !:
          let De_Colorstart(Udim(Mat De_Colorstart)) = (((Deleteindex-1) * Recordsize)+1) !:
          let De_Colorend(Udim(Mat De_Colorstart)) = (Deleteindex * Recordsize)
          if De_Deleterow(Deleteindex)=1 then !:
             let De_Color$(Udim(Mat De_Colorstart)) = "/#FF0000:#FFFF00" ! Red With Yellow Background !:
          else !:
             let De_Color$(Udim(Mat De_Colorstart)) = "/#000000:#FFFFFF" ! Black With White Background !:
             let De_Deleterow(Deleteindex)=0
       end if
    next Deleteindex
    if (Udim(Mat De_Colorstart)) then !:
       print #Window, fields "1,1,GRID "&str$(val(rows$)-1)&"/"&cols$&",ATTR" : (Mat De_Colorstart, Mat De_Colorend, Mat De_Color$)
    return
 !
 ! #Autonumber# 14000,5
 DATAEDIT: ! ***** Display A Grid Containing Raw File Data
    def library Fndataedit(Filelay$;srow$,scol$,rows$,cols$,___,Window,Selectedrow,Index,Or_Recordlocation,X$,Key,Key$,Clearflag$*1,Rowcount,Shouldsave,Saveindex,Saveloop,Saverecordsub,Recordsize,Deleteindex,Rebuildcolor,Changedrowcount,Oldchangeddatasize,Oldchangedsubssize,Somethingfound,Choice)
       library : Fngetfilenumber, fnOpenFile, fnCloseFile
       let fnvalidatenonguirowcol(srow$,scol$,rows$,cols$)
       open #(Window:=Fngetfilenumber) : "sRow="&srow$&",sCol="&scol$&",Rows="&rows$&",Cols="&cols$&",Caption= View '"&Filelay$&"' File ... F4 to Search ... F5 to Save Changes ,Border=S",display,outin
       let De_Datafile=Fnopen(Filelay$,Mat De_Data$,Mat De_Data,Mat Dc_Forms$,0,1,0,"",Mat De_Dfdescr$,Mat De_Widths)
       if De_Datafile then
          let Fncalculatefieldforms(Mat De_Fieldforms$,Mat De_Widths,Mat De_Dfdescr$)
          let Recordsize=Udim(Mat De_Widths)
          mat De_Blank$(Recordsize)
          print #Window, fields rows$&",2,CC 10,,B15;"&rows$&",12,CC 10,,B16;"&rows$&",22,CC 10,,B5;"&Rows$&","&str$(val(cols$)-10)&",CC 10,,B54" : "Add","Delete","Save","Quit"
          print #Window, fields "1,1,GRID "&str$(val(rows$)-1)&"/"&cols$&",HEADERS" : (Mat De_Dfdescr$,Mat De_Widths,Mat De_Fieldforms$)
          do  ! Whole Thing
             mat De_Outputrow$(0) : mat De_Records(0) : mat De_Deleterow(0) : let Changedrowcount=0 : mat De_Changeddata$(0) : mat De_Changedsubs(0) : let Somethingfound=0
             let Clearflag$="="
             if Trim$(Key$)="" then !:
                restore #De_Datafile: !:
             else !:
                restore #De_Datafile, search>=Trim$(Key$): nokey DECLEARENTERED
             do  ! Read Data
    DEREADNEXTDATAROW: ! Read The Next Row Here
                read #De_Datafile, using Dc_Forms$(De_Datafile) : Mat De_Data$,Mat De_Data error Ignore
                if file(De_Datafile)=10 then goto DEDONEREADINGDATAFILE
                let Somethingfound=1
                let Or_Recordlocation=Udim(Mat De_Outputrow$)
                mat De_Outputrow$(Udim(De_Outputrow$)+Recordsize) ! Add Room
                mat De_Deleterow(Udim(Mat De_Records) + 1) ! Add Row To Delete From !:
                mat De_Records(Udim(Mat De_Records) + 1) !:
                let De_Records(Udim(Mat De_Records))=Rec(De_Datafile) ! Save Record Number For Later
                if Udim(Mat De_Data$) then ! Copy Strings !:
                   mat De_Outputrow$(Or_Recordlocation+1:Or_Recordlocation+Udim(Mat De_Data$))=De_Data$
                for Index=1 to Udim(Mat De_Data) ! Copy Numerics
                   let De_Outputrow$(Or_Recordlocation+Index+Udim(Mat De_Data$))=Str$(De_Data(Index))
                next Index
                if ((X$:=Unhex$(Kstat$))="6300") then goto DEDONEREADINGDATAFILE
                if Udim(Mat De_Outputrow$)+Recordsize>1000 then goto DEDONEREADINGDATAFILE
                goto DEREADNEXTDATAROW
    DEDONEREADINGDATAFILE: ! Whole File Is Populated
                print #Window, fields "1,1,GRID "&str$(val(rows$)-1)&"/"&cols$&","&Clearflag$ : Mat De_Outputrow$
                mat De_Outputrow$(0) ! Clear Already Used Data To Go Back For More
                let Clearflag$="+"
             loop Until File(De_Datafile)=10 Or X$="6300" ! Until Eof Or Abort
             do  ! Input Data
                if Rebuildcolor then gosub UPDATECOLORS
                if Somethingfound then
                   input #Window, fields "1,1,GRID "&str$(val(rows$)-1)&"/"&cols$&",ROWCNT,CHG" : Rowcount
                   let Key=Fkey
                   if Key=54 then let Key=99
                else
                   let Choice=Msgbox("There is no data in the file. Would you like to add a row?","File Empty","YN","EXCL")
                   if Choice=2 then !:
                      let Key=15 ! Add A Row !:
                      let Somethingfound=1 !:
                   else !:
                      let Key=99 ! Exit
                end if
                if Key=15 then
                   if Rowcount then ! If There Are Already Changes Made, Save Them To Backup Arrays
                      mat De_Savedata$(Recordsize*Rowcount) ! Make Room !:
                      mat De_Savesubs(Rowcount) ! Make Room !:
                      mat De_Changeddata$((Oldchangeddatasize:=Udim(De_Changeddata$)) + Udim(De_Savedata$)) !:
                      mat De_Changedsubs((Oldchangedsubssize:=Udim(De_Changedsubs)) + Udim(De_Savesubs))
                      input #Window, fields "1,1,GRID "&str$(val(rows$)-1)&"/"&cols$&",ROWSUB,CHG,NOWAIT" : Mat De_Savesubs !:
                      input #Window, fields "1,1,GRID "&str$(val(rows$)-1)&"/"&cols$&",ROW,CHG,NOWAIT" : Mat De_Savedata$
                      mat De_Changeddata$(Oldchangeddatasize+1:Udim(De_Changeddata$)) = De_Savedata$ !:
                      mat De_Changedsubs(Oldchangedsubssize+1:Udim(De_Changedsubs)) = De_Savesubs !:
                      let Changedrowcount=Udim(Mat De_Changedsubs)
                   end if
                   print #Window, fields "1,1,GRID "&str$(val(rows$)-1)&"/"&cols$&",+" : Mat De_Blank$ ! Add A Blank Row !:
                   mat De_Records(Udim(Mat De_Records)+1) !:
                   mat De_Deleterow(Udim(Mat De_Records)) !:
                   let Curfld(1,((Udim(Mat De_Records)-1)*Recordsize) + 1)
                end if
                if Key=16 then !:
                   let De_Deleterow(Currow)=De_Deleterow(Currow)+1 ! Toggle Deleted !:
                   let Rebuildcolor = 1
                let Shouldsave=0 !:
                if (Key = 4 Or Key = 99) And (Changedrowcount Or Rowcount Or Sum(Mat De_Deleterow)) then !:
                   let Shouldsave=Msgbox("All unsaved changes will be lost. Do you want to Save first?","Search Warning","YNC","EXCL")
             loop Until ((Key=99 Or Key=4) And Shouldsave<>4) Or Key=5 ! F4 Changes Settings, F5 Saves Settings
             if Key=5 Or Shouldsave=2 then
    ! .         Save Prerecorded Changes
                for Saveloop = 1 to Changedrowcount
                   let Saverecordsub=((Saveloop-1)*Recordsize)
                   if De_Deleterow(De_Changedsubs(Saveloop))=0 then ! Skip It If Its Deleted
                      if De_Records(De_Changedsubs(Saveloop)) then !:
                         read #De_Datafile, using Dc_Forms$(De_Datafile), rec=De_Records(De_Changedsubs(Saveloop)) : Mat De_Data$, Mat De_Data
    ! .               Convert Strings Back To Numbers And Assign Back To File Arrays
                      for Saveindex = 1 to Udim(Mat De_Data$)
                         let De_Data$(Saveindex)=Trim$(De_Changeddata$(Saverecordsub+Saveindex))
                      next Saveindex
                      for Saveindex = 1 to Udim(Mat De_Data)
                         let Testconvert = Val(De_Changeddata$(Saverecordsub+Saveindex+Udim(Mat De_Data$))) conv DECONVERSIONFAILED
                         let De_Data(Saveindex)=Testconvert
                      next Saveindex
    ! .               Save The Data
                      if De_Records(De_Changedsubs(Saveloop)) then !:
                         rewrite #De_Datafile, using Dc_Forms$(De_Datafile) : Mat De_Data$, Mat De_Data !:
                      else !:
                         write #De_Datafile, using Dc_Forms$(De_Datafile) : Mat De_Data$, Mat De_Data
                   end if
                next Saveloop
    ! .         Save New Changes
                mat De_Savedata$(Recordsize*Rowcount) ! Make Room
                mat De_Savesubs(Rowcount) ! Make Room
                input #Window, fields "1,1,GRID "&str$(val(rows$)-1)&"/"&cols$&",ROWSUB,CHG,NOWAIT" : Mat De_Savesubs
                input #Window, fields "1,1,GRID "&str$(val(rows$)-1)&"/"&cols$&",ROW,CHG,NOWAIT" : Mat De_Savedata$
    ! .         One Record At A Time
                for Saveloop = 1 to Rowcount
                   let Saverecordsub=((Saveloop-1)*Recordsize)
                   if De_Deleterow(De_Savesubs(Saveloop))=0 then ! Skip It If Its Deleted
                      if De_Records(De_Savesubs(Saveloop)) then !:
                         read #De_Datafile, using Dc_Forms$(De_Datafile), rec=De_Records(De_Savesubs(Saveloop)) : Mat De_Data$, Mat De_Data
    ! .               Convert Strings Back To Numbers And Assign Back To File Arrays
                      for Saveindex = 1 to Udim(Mat De_Data$)
                         let De_Data$(Saveindex)=Trim$(De_Savedata$(Saverecordsub+Saveindex))
                      next Saveindex
                      for Saveindex = 1 to Udim(Mat De_Data)
                         let Testconvert = Val(De_Savedata$(Saverecordsub+Saveindex+Udim(Mat De_Data$))) conv DECONVERSIONFAILED
                         let De_Data(Saveindex)=Testconvert
                      next Saveindex
    ! .                Save The Data
                      if De_Records(De_Savesubs(Saveloop)) then !:
                         rewrite #De_Datafile, using Dc_Forms$(De_Datafile) : Mat De_Data$, Mat De_Data !:
                      else !:
                         write #De_Datafile, using Dc_Forms$(De_Datafile) : Mat De_Data$, Mat De_Data
                   end if
                next Saveloop
                for Deleteindex=1 to Udim(Mat De_Deleterow)
                   if De_Deleterow(Deleteindex) then
                      if De_Records(Deleteindex) then !:
                         delete #De_Datafile, rec=De_Records(Deleteindex):
                      let De_Deleterow(Deleteindex)=2 ! Clear Them To White Next Round
                   end if
                next Deleteindex
                gosub UPDATECOLORS
                let Msgbox("Update Complete!","Update")
             end if
             if Key=4 then let Key$=Fninputkey$(Kln(De_Datafile))
          loop Until Key=99
          let fnclosefile(De_Datafile,filelay$)
       end if
       close #Window:
    fnend
 DECLEARENTERED: ! Invalid Key Entered
    let Msgbox("Key Not Found")
    let Key$=""
    retry
 DECONVERSIONFAILED: ! Conversion Failed Saving Numeric Field
    let Testconvert=De_Data(Saveindex) ! Keep Existing Value, New Value Failed
    continue

 GenerateCode: ! This function generates code if code templates are available
    def fnGenerateCode(FileLay$)
       ! Read the Templates Directory
       ! Open child window
       ! allow user to select code template
       ! call fnReadEntireLayout
       ! run code template
       
       ! code templates are library functions. They can do their own input/output.
    fnend
 !
 !
 ! #Autonumber# 19000,10
 FILEIOLIBRARY: ! ********************* File Library ********************
 !
 !
 GETFILENUMBER: ! This Function Finds The Next Empty File Channel
    def library Fngetfilenumber(;Start,Count,___,I)
       if Start=-1 then
          let Fnsettings(D$,D1,D2,D3,Start)
       end if
       if (Start) then let Start-=1
       let Count=max(Count,1)
       do
          if Start>=199 and Start<300 then let Start=300 : let I=0 ! Skip over the invalid 200s
          if File(Start:=Start+1)=-1 then
             let I=I+1
          else
             let I=0
          end if
       loop until I=Count
       let Fngetfilenumber=(Start-(Count-1))
    fnend

 !
 ! #Autonumber# 20000,10
 OPENFILE: ! This Function Opens The Requested File And Returns Filenum
       def library Fnopenfile(&Filename$, Mat F$, Mat F, Mat Form$;Inputonly,Keynum,Dont_Sort_Subs,&Path$,Mat Description$,Mat Fieldwidths,Mat FileIOSubs$,SupressPrompt,___,Filenumber,Stringsize,Numbersize,Dummy,Index,Ver,Promptoncreate,Oktocreate,Createlogfile,Form$*2000,StartFileNumber,CountFileNumber,FileLay$*255,CheckIndex)
          dim Keyname$(1)*255,Kpos$(1)*80,Klen$(1)*80
          dim Fm$*8000,Message$*60,Dummy$*255
          dim LayoutPath$*255
          let Fm$=Message$=Dummy$=""

          library : Fngetfilenumber, Fnlog, Fnerrlog
          let Fnsettings(Dummy$,Promptoncreate,Createlogfile,EnforceDupkeys,StartFileNumber,CheckIndex)
          if Not (Keynum) then let Keynum=1
          if Trim$(Path$)<>"" And Path$(Len(Path$):Len(Path$))<>"\" then let Path$=Path$&"\"
          let Filelay$=Filename$ ! Make Backup So That We Can Use This Later For Versioning Logic
          if Fnreadfilelayout(Filename$,Recl$,Mat Keyname$,Mat Kpos$,Mat Klen$,Fm$, Stringsize, Numbersize,Dont_Sort_Subs,Ver,Mat Description$,Mat Fieldwidths,Mat FileIOSubs$) then ! Reads Layout And Applies Subscripts
             if fn42 then
                let Form$=fm$(1:2000)
             else
                let Form$=trim$(fm$(1:255))
             end if
             if Not Exists(Path$&Filename$) then
                if SupressPrompt then
                   let OkToCreate=SupressPrompt-1
                else if Promptoncreate then
                   let Message$=Path$&Filename$
                   if Len(Trim$(Message$))>41 then let Message$=Message$(1:38)&"..."
                   let Message$='Should I create "'&Message$&'"?'
                   let Oktocreate=Fnmessagebox(Message$,"File Not Found")
                else
                   let Oktocreate=1
                end if
                if Oktocreate then
                   let Fncreate(Filename$,Recl$,Mat Keyname$,Mat Kpos$,Mat Klen$,Ver,Filelay$,Path$)
                end if
             end if
             if Exists(Path$&Filename$) then
                if Inputonly then
                   do
                      if Udim(Mat Keyname$)>0 then
                         let fnCheckIndex(Path$&FileName$,Path$&Keyname$(KeyNum),Kpos$(KeyNum),Klen$(KeyNum),CheckIndex,CreateLogFile,KeyNum,EnforceDupkeys)
                         open #(Filenumber:=Fngetfilenumber(StartFileNumber)): "name="&Path$&Filename$&", kfname="&Path$&Keyname$(Keynum)&",shr",internal, input, keyed ioerr ERROR_OPENFILE
                      else
                         open #(Filenumber:=Fngetfilenumber(StartFileNumber)): "name="&Path$&Filename$&",shr",internal, input, relative ioerr ERROR_OPENFILE
                      end if
                   loop While Fnwrongversion(Filenumber,Filelay$,Ver,Path$)
                else
                   do
                      if Udim(Mat Keyname$)>0 then
                         let fnCheckIndex(Path$&FileName$,Path$&Keyname$(KeyNum),Kpos$(KeyNum),Klen$(KeyNum),CheckIndex,CreateLogFile,KeyNum,EnforceDupkeys)
                         open #(Filenumber:=Fngetfilenumber(StartFileNumber,udim(KeyName$))): "name="&Path$&Filename$&", kfname="&Path$&Keyname$(Keynum)&",shr",internal, outin, keyed ioerr ERROR_OPENFILE
                      else
                         open #(Filenumber:=Fngetfilenumber(StartFileNumber)): "name="&Path$&Filename$&",shr",internal, outin, relative ioerr ERROR_OPENFILE
                      end if
                   loop While Fnwrongversion(Filenumber,Filelay$,Ver,Path$)
                   let CountFileNumber=FileNumber
                   for Index=1 to Udim(Keyname$) ! Outin Requires All Keys To Be Opened
                      if Index<>Keynum then
                         let fnCheckIndex(Path$&FileName$,Path$&Keyname$(Index),Kpos$(Index),Klen$(Index),CheckIndex,CreateLogFile)
                         let CountFileNumber+=1
                         open #(CountFileNumber): "name="&Path$&Filename$&", kfname="&Path$&Keyname$(Index)&",shr",internal, outin, keyed
                         mat Form$(Max(Udim(Mat Form$),CountFileNumber))
                         let Form$(CountFileNumber)=Form$
                      end if
                   next Index
                end if
                mat Form$(Max(Udim(Mat Form$),Filenumber))
                let Form$(Filenumber)=Form$
                mat F$(Stringsize)
                mat F(Numbersize)
                let Fnopenfile=Filenumber
                if Createlogfile then let Fnlog(Filename$&" file opened.")
             else
                if Createlogfile then let Fnlog(Filename$&" file could not be opened - File Not Found")
             end if
          else
             print "Unable to open file layout: "&Filename$
             print "Make sure it exists, and its not currently in use."
             pause
             stop
          end if
       fnend
 ERROR_OPENFILE: ! An Error Was Found Opening The File
       print "Error parsing file layout or opening file: "&Str$(Err)&" on line: "&Str$(Line)
       print "A key specified in your file layout could not be found."
       print "Check your file layout header for errors."
       pause  ! Give User A Chance To Check Variables
       execute "system"
 !
 ! #Autonumber# 21000,10
 CREATE: ! This Should Create The Given File If It Does Not Exist
       def Fncreate(Filename$*255,Recl$,Mat Keys$,Mat Kpos$,Mat Klen$,Ver,Filelay$*255;Path$*255,___,Index,Filenumber)
          if Udim(Mat Keys$)>0 then
             open #(Filenumber:=Fngetfilenumber): "Name="&Path$&Filename$&", "&Recl$&", kfname="&Path$&Keys$(1)&", kps="&Kpos$(1)&", kln="&Klen$(1)&",new",internal,output,keyed
          else
             open #(Filenumber:=Fngetfilenumber): "Name="&Path$&Filename$&", "&Recl$&",new", internal, output, relative
          end if
          let Version(Filenumber,Ver)
          close #Filenumber:
          for Index=2 to Udim(Mat Keys$)
             execute "index "&Path$&Filename$&" "&Path$&Keys$(Index)&" "&Kpos$(Index)&" "&Klen$(Index)&" dupkeys -N"
          next Index
          let Fncreateversionsaveinfo(Filelay$)
       fnend
 !
 CREATEVERSIONSAVEINFO: ! Backs Up The File Layout And Saves Version Information
       def Fncreateversionsaveinfo(Filelay$*255;Savelay,Newlay,Filename$*255,Prefix$,Dummy$*255,Keyname$,Vers$,Filelayoutpath$*255,Oldfilelayout$)
          let Fnsettings(Filelayoutpath$) ! Retrieve Settings
          if ~Exists(Filelayoutpath$&"version") then
             execute "*mkdir "&Filelayoutpath$&"version"
          end if
          open #(Newlay:=Fngetfilenumber): "Name="&Filelayoutpath$&Filelay$, display,input
          input #Newlay: Filename$,Prefix$,Vers$
          open #(Savelay:=Fngetfilenumber): "Name="&Filelayoutpath$&"version\"&Filelay$&"."&Trim$(Str$(Val((Vers$))))&", replace", display, output
          print #Savelay: Fncalculatebackupfilename$(Trim$(Filename$))&", o"&Trim$(Prefix$)&", "&Trim$(Vers$)
          linput #Newlay: Dummy$
          do While Uprc$(Dummy$(1:5))<>"RECL="
             print #Savelay: Fncalculatebackupfilename$(Dummy$(1:Pos(Dummy$,",")-1)) & Trim$(Dummy$(Pos(Dummy$,","):Len(Dummy$)))
             linput #Newlay: Dummy$
          loop
 COPYNEXTLINE: ! Copy The Rest Of The File
          print #Savelay: Trim$(Dummy$)
          linput #Newlay: Dummy$ eof DONECOPYLINES
          goto COPYNEXTLINE
 DONECOPYLINES: ! File Is Finished
          close #Newlay:
          close #Savelay:
       fnend
 !
 CHECKVERSIONSAVEINFO: ! Ensures Version Save Information Exists
       def Fncheckversionsaveinfo(Filelay$*255,Ver;___,Filelayoutpath$*255)
          let Fnsettings(Filelayoutpath$)
          if ~(Trim$(Filelay$(pos(Trim$(Filelay$),".",-1):Len(Trim$(Filelay$))))="."&Trim$(Str$(Ver))) then
             if (~Exists(Filelayoutpath$&"version")) Or (~Exists(Filelayoutpath$&"version\"&Filelay$&"."&Trim$(Str$(Ver)))) then
                let Fncreateversionsaveinfo(Filelay$)
             end if
          end if
       fnend
 !
 CALCULATEBACKUPFILENAME: !  Returns The Backup File Name Of The Given File Name
       def Fncalculatebackupfilename$*255(Newfilename$*255;___,Lastslash)
          let Lastslash=Pos(Newfilename$,"\",-1)
          let Newfilename$(Lastslash+1:Lastslash)="o"
          let Fncalculatebackupfilename$=Newfilename$
       fnend
 !
 CALCULATENEWFILENAME: ! Returns The New File Name Of The Given Backup File Name
       def Fncalculatenewfilename$*255(Backupfilename$*255;___,Lastslash)
          let Lastslash=Pos(Backupfilename$,"\",-1)
          if Backupfilename$(Lastslash+1:Lastslash+1)="o" then
             let Backupfilename$(Lastslash+1:Lastslash+1)=""
          end if
          let Fncalculatenewfilename$=Backupfilename$
       fnend
 !
 ! #Autonumber# 22000,10
 CheckIndex: ! Checks to ensure Indexes are up to date
       def fnCheckIndex(MainFile$*255,KeyFile$*255,Kpos$*50,Klen$*50,CheckIndex;Logging,Index,EnforceDupkeys,___,Dupkeys)
          if EnforceDupkeys and Index=1 then let Dupkeys=0 else let Dupkeys=1
          if Exists(KeyFile$) then
             if CheckIndex then
                if fnGetFileDateTime$(KeyFile$)<>fnGetFileDateTime$(MainFile$) then
                   let fnRebuildIndex(MainFile$,Keyfile$,Kpos$,Klen$,1,Logging,Dupkeys)
                end if
             end if
          else
             let fnRebuildIndex(MainFile$,KeyFile$,Kpos$,Klen$,0,Logging,Dupkeys)
          end if
       fnend

 RebuildIndex: ! Rebuilds an Index that was missing or incomplete
       def fnRebuildIndex(MainFile$*255,KeyFile$*255,Kpos$*50,Klen$*50;Update,Logging,Dupkeys)
          if Update then
             if Dupkeys then
                execute "*index "&MainFile$&" "&KeyFile$&" "&Kpos$&" "&Klen$&" dupkeys replace shr -N" error Ignore
             else
                execute "*index "&MainFile$&" "&KeyFile$&" "&Kpos$&" "&Klen$&" replace shr -N" error Ignore
             end if
          else
             if Dupkeys then
                execute "*index "&MainFile$&" "&KeyFile$&" "&Kpos$&" "&Klen$&" dupkeys shr -N" error Ignore
             else
                execute "*index "&MainFile$&" "&KeyFile$&" "&Kpos$&" "&Klen$&" shr -N" error Ignore
             end if
          end if
          if Logging then let fnLog("Autocreate Index "&MainFile$&" "&KeyFile$&" "&Kpos$&" "&Klen$)
       fnend

 WRONGVERSION: ! Checks Version, Closes And Updates Files If Wrong Version
       def Fnwrongversion(Filenumber,Filelay$*255,Ver;Path$*255,___,Old)
          if (Old:=Version(Filenumber))>=Ver then
             let Fnwrongversion=0 ! Success
             let Fncheckversionsaveinfo(Filelay$,Ver)
          else
             close #Filenumber:
             let Fnupdate(Filelay$,Old,Path$)
             let Fnwrongversion=1 ! Failure, But Version Was Fixed, So Go Back And Reopen It
          end if
       fnend
 !
 ! #Autonumber# 23000,5
 UPDATE: ! Updates File To Latest Version
       def Fnupdate(Filelay$*255,Oldver;&Path$,__,Index,Oldfile,Newfile,Opre$,Npre$,Nndex,Oldfilename$*255,Lastupdatedkey,Errindex,Lastpercent,Reccount,Useraborted,Window,Interval,Numrecs,Oldfilelay$*255)
          let Fnsettings(Layoutpath$)
          on error goto FILEINUSE ! Call Rollback Processing For No Changes Made
          open #(Window:=Fngetfilenumber): "SRow=11,SCol=2,Rows=2,Cols=78,Caption= Updating '"&Filelay$&"' File - Please Wait ,Border=S",display,outin
 !
          for Index=1 to 78 !:
             print #Window, fields "2,"&Str$(Index)&",C 1" : "." !:
          next Index
 !
          dim Fm$(1)*1000,Nf$(1)*800,Nf(1),Of$(1)*800,Of(1),Nssubs$(1)*80,Ossubs$(1)*80,Nnsubs$(1)*80,Onsubs$(1)*80,Okeys$(1)*80
 !
          library : Fnopenfile, Fnclosefile, Fnreadsubs
 !
          let Oldfilelay$="version\"&Filelay$&"."&Str$(Oldver)
 !
          if Exists(Layoutpath$&Oldfilelay$) then
             let Fnfindindexes(Oldfilelay$,Oldfilename$,Mat Okeys$)
             print #Window, fields "1,1,C 78" : "Making Backup Copy of "&Path$&Fncalculatenewfilename$(Oldfilename$)
             execute "*copy "&Path$&Fncalculatenewfilename$(Oldfilename$)&" "&Path$&Oldfilename$&" -N -D"
             execute "*free "&Path$&Fncalculatenewfilename$(Oldfilename$)&" -N"
             on error goto FILEINUSEKEY ! Call Rollback Processing For File Changed And Some Keys
             for Index=1 to Udim(Okeys$)
                print #Window, fields "1,1,C 78" : "Making Backup Copy of "&Path$&Fncalculatenewfilename$(Okeys$(Index))
                execute "*copy "&Path$&Fncalculatenewfilename$(Okeys$(Index))&" "&Okeys$(Index)&" -N -D"
                execute "*free "&Path$&Fncalculatenewfilename$(Okeys$(Index))&" -N"
             next Index
             on error goto ROLLBACKINFULL ! Call Rollback Processing For File / All Keys Changed
             let G_Updating=1
             print #Window, fields "1,1,C 78" : "Opening old version of file."
             let Oldfile=Fnopen(Oldfilelay$,Mat Of$,Mat Of, Mat Fm$,0,0,0,Path$)
             let Fnreadsubs(Oldfilelay$,Mat Ossubs$,Mat Onsubs$,Opre$)
             print #Window, fields "1,1,C 78" : "Creating new version of file."
             let Newfile=Fnopen(Filelay$,Mat Nf$,Mat Nf,Mat Fm$,0,0,0,Path$) ! Will Automatically Create
             let Fnreadsubs(Filelay$,Mat Nssubs$,Mat Nnsubs$,Npre$)
             print #Window, fields "1,1,C 78" : "Preforming File Update. SHIFT-A to abort."
             let Numrecs=Lrec(Oldfile)
 READOLDRECORD: ! Read The Old Record Here
             read #Oldfile, using Fm$(Oldfile), release: Mat Of$, Mat Of eof DONEUPDATING
             mat NF$=("")
             mat NF=(0)
             if Int(((Reccount+=1)/Lrec(Oldfile))*78)>Lastpercent then
                for Index=Max(Lastpercent,1) to Int((Reccount/Numrecs)*78)
                   print #Window, fields "2,"&Str$(Index)&",C 1" : "o"
                next Index
                let Lastpercent=Int((Reccount/Numrecs)*78)
             end if
             if ~Mod(Reccount,3) then print #Window, fields "1,42,CR 37" : "Completed: "&Str$(Reccount)&" / "&Str$(Numrecs)
             for Index=1 to Udim(Ossubs$) ! Copy String Values
                if (Nndex:=Srch(Mat Nssubs$,Ossubs$(Index)))>0 then
                   let NF$(Nndex)=OF$(Index)
                end if
             next Index
             for Index=1 to Udim(Onsubs$) ! Copy Number Values
                if (Nndex:=Srch(Mat Nnsubs$,Onsubs$(Index)))>0 then
                   let NF(Nndex)=OF(Index)
                end if
             next Index
             write #Newfile, using Fm$(Newfile) : Mat Nf$, Mat Nf
             if Kstat$="A" then let Useraborted=1 : goto ROLLBACKINFULL
             goto READOLDRECORD
 DONEUPDATING: ! We Are Finished
             let Fnclosefile(Oldfile,Oldfilelay$)
             let Fnclosefile(Newfile,Filelay$)
             close #Window:
             let G_Updating=0 ! We Are Done Updating
          else
             print "Error: Unable to locate old version file layout: "&Layoutpath$&Oldfilelay$
             pause
             execute "system"
          end if
          on error system  ! Turn Error Checking Back Off
       fnend
 !
 ! Error Checking Rollback Update Routine.       #Autonumber# 23600,5
 ROLLBACKINFULL: ! Close All Files And Roll Back
       on error system
       let UpdateErrorRecieved=Err
       let UpdateErrorLine=Line
       if Oldfile then let Fnclosefile(Oldfile,Oldfilelay$)
       if Newfile then let Fnclosefile(Newfile,Filelay$)
       let Lastupdatedkey=Udim(Okeys$) ! Set Value To Roll Back All Indexes
 !
 FILEINUSEKEY: ! Error In Second Part. Partially Roll Back
       on error system
       if UpdateErrorRecieved=0 then let UpdateErrorRecieved=Err
       if UpdateErrorLine=0 then let UpdateErrorLine=Line
       print "Error encountered or User abort: Rolling back to previous version. Type GO[ENTER] to Quit."
       if ~Lastupdatedkey then let Lastupdatedkey=Index-1
       for Errindex=1 to Lastupdatedkey ! Roll Back All Successful Indexes
          if Exists(Path$&Okeys$(Errindex)) then !:
             execute "copy "&Path$&Okeys$(Errindex)&" "&Path$&Fncalculatenewfilename$(Okeys$(Errindex)) ! Copy Backup File To Origional File
       next Errindex
       if Exists(Path$&Oldfilename$) then !:
          execute "copy "&Path$&Oldfilename$&" "&Path$&Fncalculatenewfilename$(Oldfilename$)
 !
 FILEINUSE: ! Error In First Part
       on error system
       if UpdateErrorRecieved=0 then let UpdateErrorRecieved=Err
       if UpdateErrorLine=0 then let UpdateErrorLine=Line
       print Fnerrormessage$(UpdateErrorRecieved,UpdateErrorLine)
       pause
       execute "system"
 !
 ! #Autonumber# 23800,5
 ERRORMESSAGES: ! Return The Proper Error Message For Rollback Errors
       def Fnerrormessage$*80(Errornum,Errorline)
          do
             if Str$(Errorline)(1:2)="21" then
                let Fnerrormessage$="Error during create: Check heading information in file layout."
                exit do
             end if
             if Errornum=4148 then
                let Fnerrormessage$="The file was in use. Please close all other copies of BR and try again."
                exit do
             end if
             if Useraborted then
                let Fnerrormessage$="User Aborted."
                exit do
             end if
             let Fnerrormessage$="Error updating file: "&Str$(Errornum)&" occured on line: "&Str$(Errorline)
             exit do
          loop
       fnend

 ! #Autonumber# 24000,2
 FINDINDEXES: ! ***** Reads A File Layout And Finds All Indexes
       def Fnfindindexes(Layoutname$*255;&Filename$,Mat Keys$)
          ! Included for Backwards Compatability
          library : fnReadLayoutHeader
          let fnFindIndexes=fnReadLayoutHeader(LayoutName$,FileName$,Mat Keys$)
       fnend

 ReadEntireLayout: ! Reads the entire layout into arrays
       def library fnReadEntireLayout(Layoutname$*255;&Filename$,&Prefix$,Mat Keys$,Mat KeyDescription$,Mat Ssubs$,Mat Nsubs$,Mat Sspec$,Mat Nspec$,Mat Sdescription$,Mat Ndescription$,Mat Spos,Mat Npos,___,FileNumber)
          library : fnReadLayoutHeader, fnReadLayoutArrays
          let filenumber=fnReadLayoutHeader(Layoutname$,Filename$,mat Keys$,mat KeyDescription$,1)
          let fnReadEntireLayout=fnReadLayoutArrays(Layoutname$,Prefix$,Mat Ssubs$,Mat Nsubs$,Mat Sspec$,Mat Nspec$,Mat Sdescription$,Mat Ndescription$,Mat Spos,Mat Npos,FileNumber)
       fnend

 ReadLayoutHeader: ! Reads the layout header and returns Arrays
       def library FnReadLayoutHeader(Layoutname$*255;&Filename$,Mat Keys$,Mat KeyDescription$,LeaveOpen,___,Layout,Count,Keyname$*80,Description$*80,Prefix$*80,Vers$*80,BKeys,BKeyDescription)
          library : Fngetfilenumber
          
          let Fnsettings(Layoutpath$)

          if trim$(layoutname$)<>"" and Exists(Layoutpath$&Layoutname$) then
             if Fnsmatrixpresent(Mat Keys$) then let Bkeys=1
             if FnSMatrixPresent(Mat KeyDescription$) then let BKeyDescription=1

             if BKeys then mat Keys$(0)
             if BKeyDescription then mat KeyDescription$(0)

             open #(Layout:=Fngetfilenumber): "Name="&Layoutpath$&Layoutname$&",shr", display, input
             input #Layout: Filename$,Prefix$,Vers$
             input #Layout: Keyname$,Description$
             do While Uprc$(Keyname$(1:4))<>"RECL"
                let Count+=1
                if BKeys then
                   mat Keys$(Count)
                   let Keys$(Count)=trim$(Keyname$)
                end if
                if BKeyDescription then
                   Mat KeyDescription$(Count)
                   let KeyDescription$(Count)=trim$(Description$)
                end if
                input #Layout: Keyname$,Description$
             loop
             if ~LeaveOpen then
                close #Layout:
             end if
          end if
          if LeaveOpen then
             let fnReadLayoutHeader=Layout
          else
             let FnReadLayoutHeader=Count
          end if
       fnend

 READSUBS: ! Read File Layout, Returning All Subscripts As An Array
       def library Fnreadsubs(Filename$*255,Mat Ssubs$,Mat Nsubs$,&Prefix$)
          ! Included for Backwards Compatability Only
          library : fnReadLayoutArrays
          let fnReadLayoutArrays(Filename$,Prefix$,mat SSubs$,mat NSubs$)
       fnend
 !
 READLAYOUTARRAYS: ! Read File Layout, Returning Everything As Some Arrays
       def library Fnreadlayoutarrays(Layoutname$*255,&Prefix$;Mat Ssubs$,Mat Nsubs$,Mat Sspec$,Mat Nspec$,Mat Sdescription$,Mat Ndescription$,Mat Spos,Mat Npos,AlreadyOpenFileNumber,___,Index,Dummy$*255,Dummy2$*255,Subname$*255,Layout,Description$*255,Spec$*255,Bssubs,Bnsubs,Bsdescription,Bndescription,Bsspec,Bnspec,Bspos,Bnpos,Position,Count,Line$*512)
          library : fnGetFileNumber
 !
          let Position=1
          let Fnsettings(Layoutpath$) ! Read File Layout Path
 !
          if trim$(layoutname$)<>"" and Exists(Layoutpath$&Layoutname$) then
             if Fnsmatrixpresent(Mat Ssubs$) then let Bssubs=1
             if Fnsmatrixpresent(Mat Nsubs$) then let Bnsubs=1
             if Fnsmatrixpresent(Mat Sspec$) then let Bsspec=1
             if Fnsmatrixpresent(Mat Nspec$) then let Bnspec=1
             if Fnsmatrixpresent(Mat Sdescription$) then let Bsdescription=1
             if Fnsmatrixpresent(Mat Ndescription$) then let Bndescription=1
             if Fnnmatrixpresent(Mat Spos) then let Bspos=1
             if Fnnmatrixpresent(Mat Npos) then let Bnpos=1
 !
             if Bssubs then mat Ssubs$(0)
             if Bnsubs then mat Nsubs$(0)
             if Bsspec then mat Sspec$(0)
             if Bnspec then mat Nspec$(0)
             if Bsdescription then mat Sdescription$(0)
             if Bndescription then mat Ndescription$(0)
             if Bspos then mat Spos(0)
             if Bnpos then mat Npos(0)
 !
             if AlreadyOpenFileNumber then
                let Layout=AlreadyOpenFileNumber
             else
                open #(Layout:=Fngetfilenumber): "Name="&Layoutpath$&Layoutname$&",shr", display, input
                input #Layout: Dummy$,Prefix$,Dummy2$
                let Prefix$=Trim$(Prefix$)
                do While Uprc$(Dummy$(1:4))<>"RECL"
                   input #Layout: Dummy$,Dummy2$
                loop
             end if
 READNEXTLAYOUTLINE: ! Read The Next Line For Processing
             linput #Layout: Line$ eof DONEREADLAYOUTARRAYS
             let SubName$=Trim$(Srep$(Line$(1:pos(Line$,",")-1),Chr$(9)," "))
             let Line$=Line$(pos(Line$,",")+1:len(Line$))
             let Description$=Trim$(Srep$(Line$(1:pos(Line$,",")-1),Chr$(9)," "))
             let Line$=Line$(pos(Line$,",")+1:len(Line$))
             if pos(Line$,",") then
                let Spec$=Trim$(Srep$(Line$(1:pos(Line$,",")-1),Chr$(9)," "))
             else
                let Spec$=Trim$(Srep$(Line$,Chr$(9)," "))
             end if

             if Trim$(Uprc$(Spec$))(1:2)<>"X " then
                if Trim$(Subname$)<>"" then
                   if Pos(Subname$,"$") then
                      Count+=1
                      if Bssubs then
                         mat Ssubs$(Udim(Ssubs$)+1)
                         let Ssubs$(Udim(Ssubs$))=Trim$(Srep$(Subname$,"$",""))
                      end if
                      if Bsspec then
                         mat Sspec$(Udim(Sspec$)+1)
                         let Sspec$(Udim(Sspec$))=Trim$(Spec$)
                      end if
                      if Bsdescription then
                         mat Sdescription$(Udim(Sdescription$)+1)
                         let Sdescription$(Udim(Sdescription$))=Trim$(Description$)
                      end if
                      if Bspos then
                         mat Spos(Udim(Spos)+1)
                         let Spos(Udim(Spos))=Position
                      end if
                   else
                      if Bnsubs then
                         mat Nsubs$(Udim(Nsubs$)+1)
                         let Nsubs$(Udim(Nsubs$))=Trim$(Subname$)
                      end if
                      if Bnspec then
                         mat Nspec$(Udim(Nspec$)+1)
                         let Nspec$(Udim(Nspec$))=Trim$(Spec$)
                      end if
                      if Bndescription then
                         mat Ndescription$(Udim(Ndescription$)+1)
                         let Ndescription$(Udim(Ndescription$))=Trim$(Description$)
                      end if
                      if Bnpos then
                         mat Npos(Udim(Npos)+1)
                         let Npos(Udim(Npos))=Position
                      end if
                   end if
                end if
             end if
             let Position+=Fnlengthof(Trim$(Spec$))
             goto READNEXTLAYOUTLINE
 DONEREADLAYOUTARRAYS: ! We Finished With All The File Layout
             close #Layout:
             fnReadLayoutArrays=Count
          end if
       fnend

 ReadKeyFiles: ! This function reads the key file list of a file layout
       def library fnReadKeyFiles(layout$,mat keys$;___,filename$*255)
          ! Included for Backwards Compatability
          let fnFindIndexes(layout$,filename$,mat keys$)
       fnend

 BuildKey: ! This function builds a key off of mat F$ and mat F
       def library fnBuildKey$*255(layout$*30,mat f$,mat f;keynum,___,filename$*80,prefix$,Index,KeyPart$*30,KeyFields$*80,Key$*255)

          dim BK_Keys$(1)*80
          dim BK_KeyFields$(1)*80
          dim BK_SSubs$(1)*80
          dim BK_NSubs$(1)*80
          dim BK_SSpec$(1)*80
          dim BK_NSpec$(1)*80
          dim BK_LastLayout$*30

          if (trim$(layout$)<>"") and (udim(mat f$)+udim(mat F)) then
             if Layout$<>BK_LastLayout$ then

                library : fnReadEntireLayout, fnKey$

                mat BK_Keys$(0)
                mat BK_KeyFields$(0)

                let fnReadEntireLayout(layout$,filename$,prefix$,mat BK_Keys$,mat BK_KeyFields$,mat BK_SSubs$,mat BK_NSubs$,mat BK_SSpec$,mat BK_NSpec$)

                for Index=1 to udim(mat BK_sSubs$)
                   let BK_sSubs$(Index)=lwrc$(BK_sSubs$(Index))
                next Index
                for Index=1 to udim(mat BK_nSubs$)
                   let BK_nSubs$(Index)=lwrc$(BK_nSubs$(Index))
                next Index
             
                let BK_LastLayout$=Layout$

             end if

             if udim(mat BK_Keys$) then

                if KeyNum=0 then let KeyNum=1
                let KeyFields$=lwrc$(trim$(BK_KeyFields$(KeyNum)))

                do
                   if POS(KeyFields$,"/") then
                      let KeyPart$=KeyFields$(1:pos(KeyFields$,"/")-1)
                      let KeyFields$(1:pos(KeyFields$,"/"))=""
                   else
                      let KeyPart$=KeyFields$
                      let KeyFields$=""
                   end if

                   if (Index:=srch(mat BK_sSubs$,KeyPart$))>0 then
                      let Key$=Key$&rpad$(rtrm$(F$(Index))(1:fnLengthOf(BK_sSpec$(Index))),fnLengthOf(BK_sSpec$(Index)))
                   else if (Index:=srch(mat BK_nSubs$,KeyPart$))>0 then
                      let Key$=Key$&cnvrt$(BK_nSpec$(Index),F(Index))
                   end if
                loop while len(KeyFields$)
          
                let fnBuildKey$=Key$
             end if
          end if
       fnend
 !
 ! #Autonumber# 25000,10
 CLOSEFILE: ! ***** Close A File, Closing All Indexes == Use Only With Files Opened I/O With This Library
       def library Fnclosefile(Filenumber, Filelay$*255;Path$*255,___,Remaining,Filename$*255)
          let Remaining=Fnfindindexes(Filelay$,Filename$)

          do While Filenumber<=999
             if uprc$(os_filename$(file$(filenumber)))=uprc$(os_filename$(Path$&filename$)) then
                close #(Filenumber): ! Close Only If Its This File
                let Remaining-=1
             end if
             let Filenumber+=1
          loop While Remaining>0
       fnend
 !
 ! #Autonumber# 25500,5
 MAKESUBPROC: ! Read File Layout, Returning All Subscripts As A Procfile
       def library Fnmakesubproc(Filename$*255;Mat Subs$,___,Index,Dummy$*255,Dummy2$*255,Subname$*255,Layout,Subs,Prefix$*255,LayoutPath$*255,Stringsize,Numbersize,Line$*512)
          let Fnsettings(Layoutpath$)

          open #(Layout:=Fngetfilenumber): "Name="&Layoutpath$&Filename$&",shr", display, input
          if fnSMatrixPresent(mat Subs$) then
             mat Subs$(0)
          else
             open #(Subs:=Fngetfilenumber): "Name=subs.$$$, replace", display, output
          end if
          
          input #Layout: Dummy$,Prefix$,Dummy2$
          let Prefix$=Trim$(Prefix$)
          do
             input #Layout: Dummy$,Dummy2$
          loop While Uprc$(Dummy$(1:4))<>"RECL"
 !
 READNEXTSUBPROCLINE: ! Read The Next Line For Processing
          linput #Layout: Line$ eof DONEMAKESUBPROC
          if pos(Line$,",") then
             let SubName$=Trim$(Srep$(Line$(1:pos(Line$,",")-1),Chr$(9)," "))
          else
             let SubName$=Trim$(Srep$(Line$,Chr$(9)," "))
          end if

          if Trim$(Uprc$(Dummy2$))(1:2)<>"X " then
             if Trim$(Subname$)<>"" then
                if Pos(Subname$,"$") then
                   let Stringsize+=1
                   if Subs then
                      print #Subs: "let "&Trim$(Prefix$)&Trim$(Srep$(Subname$,"$",""))&"="&Str$(Stringsize)
                   else
                      let fnAddToSubsArray("let "&Trim$(Prefix$)&Trim$(Srep$(Subname$,"$",""))&"="&Str$(Stringsize),mat Subs$)
                   end if
                else
                   let Numbersize+=1
                   if Subs then
                      print #Subs: "let "&Trim$(Prefix$)&Trim$(Subname$)&"="&Str$(Numbersize)
                   else
                      let fnAddToSubsArray("let "&Trim$(Prefix$)&Trim$(Subname$)&"="&Str$(Numbersize),mat Subs$)
                   end if
                end if
             end if
          end if
          goto READNEXTSUBPROCLINE
 DONEMAKESUBPROC: ! We Finished With All The File Layout
          close #Layout:
          if Subs then close #Subs:
       fnend


 dim AddToSubsCount
 AddToSubsArray: ! Adds subscripts to a processing effecient array
       def fnAddToSubsArray(String$*70,mat Subs$;___,Index)

          let AddToSubsCount+=1
          let Index=udim(mat Subs$)

          if Index=0 or AddToSubsCount>31 then
             gosub AddNewOne
          else
             let Subs$(Index)=Subs$(Index)&":"&String$ SoFlow ErrorAddNewOne
          end if
       fnend

    ErrorAddNewOne: gosub AddNewOne : continue
    AddNewOne: ! Add a new Sub line
       let AddToSubsCount=1
       let Index+=1
       mat Subs$(Index)
       let Subs$(Index)="*"&String$
    return

 !
 ! #Autonumber# 26000,5
 READFILELAYOUT: ! Read Filelayout, Modify All Parameters, Apply Subscripts
       def Fnreadfilelayout(&Filename$,&Recl$,Mat Keyname$,Mat Kpos$,Mat Klen$,&Form$,&Stringsize,&Numbersize,Dont_Sort_Subs,&Ver,Mat Description$,Mat Fieldwidths;Mat Subs$,___,Layout,Position,Prefix$,Laststring,Lastnumber,Subs,Line$*512)
          dim Rfl_Sdescr$(1)*80,Rfl_Ndescr$(1)*80,Rfl_Descr$(1)*80,Rfl_Swidth(1),Rfl_Nwidth(1),Rfl_Width(1)
          dim StringForm$*4000, NumberForm$*4000
          dim Keyname$*255,Description$*80,Tempform$*80,Subname$*80,Ver$*80
          let StringForm$=NumberForm$=""
          let Keyname$=Description$=Tempform$=Subname$=Ver$=""
          mat Keyname$(0) : mat Kpos$(0) : mat Klen$(0) : mat Rfl_Sdescr$(0) : mat Rfl_Ndescr$(0) : mat Rfl_Descr$(0) : mat Rfl_Swidth(0) : mat Rfl_Nwidth(0) : mat Rfl_Width(0)
          let Fnsettings(Layoutpath$)
          let Stringsize=0 : let Numbersize=0 : let Form$=""

          open #(Layout:=Fngetfilenumber): "Name="&Layoutpath$&Filename$&",shr", display, input error ERRORREADFILELAYOUT

          if fnSMatrixPresent(mat Subs$) then
             mat Subs$(0)
          else
             open #(Subs:=Fngetfilenumber): "Name=subs.$$$, replace", display, output
          end if

          input #Layout: Filename$,Prefix$,Ver$ error ERRORREADFILELAYOUT
          let Ver=Val(Ver$) error ERRORREADFILELAYOUT
          let Prefix$=Trim$(Prefix$) : let Filename$=Trim$(Filename$)
          input #Layout: Keyname$,Description$ error ERRORREADFILELAYOUT
          do While Uprc$(Keyname$(1:4))<>"RECL"
             mat Keyname$(Udim(Keyname$)+1) !:
             mat Kpos$(Udim(Keyname$)) !:
             mat Klen$(Udim(Keyname$))
             let Keyname$(Udim(Keyname$))=Trim$(Keyname$) !:
             let Kpos$(Udim(Kpos$))=Trim$(Description$) !:
             let Klen$(Udim(Klen$))=Trim$(Description$)
             input #Layout: Keyname$,Description$ error ERRORREADFILELAYOUT
          loop
          let Recl$=Trim$(Keyname$)
 !
          let Position=1
 READNEXTLINE: ! Read The Next Line For Processing
          linput #Layout: Line$ eof DONEREADLAYOUT error ERRORREADFILELAYOUT
          let SubName$=Trim$(Srep$(Line$(1:pos(Line$,",")-1),Chr$(9)," "))
          let Line$=Line$(pos(Line$,",")+1:len(Line$))
          let Description$=Trim$(Srep$(Line$(1:pos(Line$,",")-1),Chr$(9)," "))
          let Line$=Line$(pos(Line$,",")+1:len(Line$))
          if pos(Line$,",") then
             let TempForm$=Trim$(Srep$(Line$(1:pos(Line$,",")-1),Chr$(9)," "))
          else
             let TempForm$=Trim$(Srep$(Line$,Chr$(9)," "))
          end if

          let Fncheckkeys(Mat Kpos$,Mat Klen$,Trim$(Subname$),Position,Trim$(Tempform$)) error ERRORREADFILELAYOUT
          if Trim$(Tempform$)<>"" then
             if Trim$(Uprc$(Tempform$))(1:2)<>"X " then
                mat Rfl_Descr$(Udim(Mat Rfl_Descr$)+1)
                let Rfl_Descr$(Udim(Mat Rfl_Descr$))=Trim$(Description$)
                mat Rfl_Width(Udim(Mat Rfl_Width)+1)
                let Rfl_Width(Udim(Mat Rfl_Width))=Fndisplaylengthof(Trim$(Tempform$))
                if Pos(Subname$,"$") then
                   let Stringsize+=1
                   if Subs then
                      print #Subs: "let "&Trim$(Prefix$)&Trim$(Srep$(Subname$,"$",""))&"="&Str$(Stringsize)
                   else
                      let fnAddToSubsArray("let "&Trim$(Prefix$)&Trim$(Srep$(Subname$,"$",""))&"="&Str$(Stringsize),mat Subs$)
                   end if
                   if Laststring<>Position And Position<>1 then let Stringform$=Stringform$&"POS "&Str$(Position)&","
                   let Fnaddtoform(Stringform$,Trim$(Tempform$))
                   let Laststring=Position+Fnlengthof(Trim$(Tempform$))
                   mat Rfl_Sdescr$(Stringsize)
                   let Rfl_Sdescr$(Stringsize)=Trim$(Description$)
                   mat Rfl_Swidth(Stringsize)
                   let Rfl_Swidth(Stringsize)=Fndisplaylengthof(Trim$(Tempform$))
                else
                   let Numbersize+=1
                   if Subs then
                      print #Subs: "let "&Trim$(Prefix$)&Trim$(Subname$)&"="&Str$(Numbersize)
                   else
                      let fnAddToSubsArray("let "&Trim$(Prefix$)&Trim$(Subname$)&"="&Str$(Numbersize),mat Subs$)
                   end if
                   if Lastnumber<>Position then let Numberform$=Numberform$&"POS "&Str$(Position)&","
                   let Fnaddtoform(Numberform$,Trim$(Tempform$))
                   let Lastnumber=Position+Fnlengthof(Trim$(Tempform$))
                   mat Rfl_Ndescr$(Numbersize)
                   let Rfl_Ndescr$(Numbersize)=Trim$(Description$)
                   mat Rfl_Nwidth(Numbersize)
                   let Rfl_Nwidth(Numbersize)=Fndisplaylengthof(Trim$(Tempform$))
                end if
             end if
             let Fnaddtoform(Form$,Trim$(Tempform$))
             let Position+=Fnlengthof(Trim$(Tempform$))
          end if
          goto READNEXTLINE
 DONEREADLAYOUT: ! We Finished With All The File Layout
          if ~Dont_Sort_Subs then let Form$=Stringform$&Numberform$
          let fnFindAndFixRpt(Form$)
          let Form$="form "&Form$(1:(Len(Form$)-1))
          let Form$=Cform$(Form$) error IGNORE
          if Fnsmatrixpresent(Mat Description$) then
             if Dont_Sort_Subs then ! Resize And Copy Unsorted
                mat Description$(Udim(Mat Rfl_Descr$))=Rfl_Descr$
             else ! Resize And Sort And Copy Seperately
                mat Description$(Stringsize+Numbersize) ! Resize
                if Stringsize>0 then mat Description$(1:Stringsize)=Rfl_Sdescr$ ! Copy Strings
                if Numbersize>0 then mat Description$(Stringsize+1:Stringsize+Numbersize)=Rfl_Ndescr$ ! Copy Numbers
             end if
          end if
          if Fnnmatrixpresent(Mat Fieldwidths) then
             if Dont_Sort_Subs then ! Resize And Copy Unsorted
                mat Fieldwidths(Udim(Mat Rfl_Width))=Rfl_Width
             else ! Resize And Sort And Copy Seperately
                mat Fieldwidths(Stringsize+Numbersize) ! Resize
                if Stringsize>0 then mat Fieldwidths(1:Stringsize)=Rfl_Swidth ! Copy Strings
                if Numbersize>0 then mat Fieldwidths(Stringsize+1:Stringsize+Numbersize)=Rfl_Nwidth ! Copy Numbers
             end if
          end if
          close #Layout:
          if Subs then close #Subs:
          let Fnreadfilelayout=1 ! Success!
       fnend
 ERRORREADFILELAYOUT: ! Error Encountered Parsing File Layout
       print "Error parsing file layout: "&Str$(Err)&" on line: "&Str$(Line)
       if Line=27060 then print "Look for a missing comma in your detail lines."
       if Line=25110 then print "Check for proper definition of your keyfiles, terminated by a 'recl=' line."
       if Line=25525 then print "Subscript too long. Look for a missing comma in your detail lines."
       if Line=56825 then print "Invalid Form statement: form "&Form$(1:(Len(Form$)-1))
       if Line=25062 then print "Problem Parsing Version Parameter: "&Ver$
       pause  ! Give User A Chance To Parse Variables
       execute "system"
 !
 ! #Autonumber# 27000,10
 CHECKKEYS: ! Routine To Check If A Given Subname Matches Part Of A Key Spec
       def Fncheckkeys(Mat Kpos$,Mat Klen$,Subname$*50,Position,Spec$*30;Index)
          let Subname$=Srep$(Subname$,"$","")
          for Index=1 to Udim(Mat Kpos$)
             let Kpos$(Index)=Srep$(uprc$(Kpos$(Index)),uprc$(Subname$),Str$(Position))
             let Klen$(Index)=Srep$(uprc$(Klen$(Index)),uprc$(Subname$),Str$(Fnlengthof(Spec$)))
          next Index
       fnend
 !
 ! #Autonumber# 27300,10
 LENGTHOF: ! ***** Returns The Length Of A Given Spec
       def library fnLength(Spec$)
          let FnLength=FnLengthOf(Spec$)
       fnend
       def Fnlengthof(Spec$*40;_Speclen)
          let Spec$=Spec$&" " ! This Will Make Sure We At Least Have 1 Space
          if Uprc$(Spec$(1:3))="PIC" then
             let _Speclen=Len(Spec$)-5 ! Pic(##) Returns 2
          else if Uprc$(Spec$(1:2))="S " then
             let _Speclen=4
          else if Uprc$(Spec$(1:2))="D " then
             let _Speclen=8
          else if Uprc$(Spec$(1:2))="L " then
             let _Speclen=9
          else
             let _Speclen=Int(Val(Spec$(Pos(Spec$," "):Len(Spec$)))) error ERRORREADFILELAYOUT
          end if
          let Fnlengthof=_Speclen
       fnend
 !
 ! #Autonumber# 27600,10
 DISPLAYLENGTHOF: ! ***** Returns The Display Length Of A Given Spec
       def library FnDisplayLength(Spec$)
          let fnDisplayLength=fndisplaylengthof(Spec$)
       fnend
       def Fndisplaylengthof(Spec$;_Speclen)
          let _Speclen=Fnlengthof(Spec$)
          let Spec$=Spec$&" "
          if Pos("S PDL D DLDHDTBLBHB ",Spec$(1:2)) then ! If Numeric Spec
             if Spec$(1:2)="PD" then ! Pd Is Different
                let _Speclen=(2*_Speclen)-1+2
             else ! All The Others Are About The Same
                let _Speclen=Len(Str$(256**_Speclen))+2
             end if
          end if
          let Fndisplaylengthof=_Speclen
       fnend
 !
 ! #Autonumber# 28000,10
 SMATRIXPRESENT: ! ***** Returns True If Optional String Array Is Given
       def Fnsmatrixpresent(;Mat X$)
          if Env$("GUIMODE")="" then ! Non Gui Versions Of Br
             let Fnsmatrixpresent=Udim(X$) ! Don't support regular test
          else
             on error goto SMATRIXNOTPRESENT
             let Fnsmatrixpresent=1 ! Assume True
             mat X$(Udim(X$)) ! Redimension Array To Test If Its Real
             goto ENDSMATRIXPRESENT
 SMATRIXNOTPRESENT: ! Error Means Optional Matrix Not Given
             let Fnsmatrixpresent=0 ! It Wasn't there
 ENDSMATRIXPRESENT: ! We Are Finished
             if G_Updating then !:
                on error goto ROLLBACKINFULL !:
             else !:
                on error system  ! Turn Off Error Checking
          end if
       fnend
 !
 ! #Autonumber# 28500,10
 NMATRIXPRESENT: ! ***** Returns True If Optional Numeric Array Is Given
       def Fnnmatrixpresent(;Mat X)
          if Env$("GUIMODE")="" then ! Non Gui Versions Of Br
             let Fnnmatrixpresent=Udim(X) ! Don't support regular test
          else
             on error goto NMATRIXNOTPRESENT
             let Fnnmatrixpresent=1 ! Assume True
             mat X(Udim(X)) ! Redimension Array To Test If Its Real
             goto ENDNMATRIXPRESENT
 NMATRIXNOTPRESENT: ! Error Means Optional Matrix Not Given
             let Fnnmatrixpresent=0 ! It Wasn't there
 ENDNMATRIXPRESENT: ! We Are Finished
             if G_Updating then !:
                on error goto ROLLBACKINFULL !:
             else !:
                on error system  ! Turn Off Error Checking
          end if
       fnend
 !
 ! #Autonumber# 29000,10
 ADDTOFORM: ! ***** This Function Adds Spec$ To Form$ Checking For Repetition. Thanks To Mikhail Zheleznov For The Formula.
       def Fnaddtoform(&Form$,Spec$*40;_Lastspec$*40,_Repetition,_Lastchunk$*40)
          let _Lastchunk$=Fnlastchunk$(Form$)
          let _Lastspec$=Fnextractspec$(_Lastchunk$)
          let _Repetition=Fnextractrepetition(_Lastchunk$)
          if Trim$(Uprc$(Spec$))=Trim$(Uprc$(_Lastspec$)) then
             let Form$=Form$(1:Len(Form$)-1-Len(_Lastchunk$))
             let Form$=Form$ & Fnbuildchunk$(_Repetition+1,_Lastspec$) & ","
          else
             let Form$=Form$&Spec$&","
          end if
       fnend
 !
 ! #Autonumber# 29500,10
 BUILDCHUNK: ! ***** Builds A Chunk Of A Form Statment
       def Fnbuildchunk$*40(Repetition,Spec$)
          if Repetition > 1 then
             let Fnbuildchunk$=Str$(Repetition)&"*"&Spec$
          else
             let Fnbuildchunk$=Spec$
          end if
       fnend
 !
 ! #Autonumber# 29600,10
 EXTRACTREPETITION: ! ***** Parses A Spec Statement To Get The Rep Count
       def Fnextractrepetition(Spec$*40)
          if Pos(Spec$,"*") then
             let Fnextractrepetition=Val(Spec$(1:Pos(Spec$,"*")-1))
          else
             let Fnextractrepetition=1
          end if
       fnend
 !
 ! #Autonumber# 29700,10
 EXTRACTSPEC: ! ***** Parses A Spec Statement To Get The Raw Spec
       def Fnextractspec$*40(Spec$*40)
          if Pos(Spec$,"*") then
             let Fnextractspec$=Spec$(Pos(Spec$,"*")+1:Len(Spec$))
          else
             let Fnextractspec$=Spec$
          end if
       fnend
 !
 ! #Autonumber# 29800,10
 LASTCHUNK: ! ***** Extracts The Final Chunk From A Form Statement
       def Fnlastchunk$*40(&Form$) ! Pass By Ref To Save On Workstack
          let Fnlastchunk$=Form$(Pos(Form$,",",-2)+1:Len(Form$)-1)
       fnend
 !
 FINDANDFIXRPT: ! Searches Your Form Statement For All Subsets Of It That May Be Shortened
       def Fnfindandfixrpt(&Form$;___,Size,Position) ! Pass And Return Byref To Save On Workstack
          dim Chunk$(1)*127
          dim SearchChunk$*4096
          let Fnparseform(Mat Chunk$,Form$)
          for Size=2 to int(Udim(Mat Chunk$)/2)
             for Position = 1 to Udim(Mat Chunk$)-Size+1
                let Fnstringtogether$(Mat Chunk$(Position:Position+Size-1),SearchChunk$)
                let Fnfixrpt(Form$,SearchChunk$)
             next Position
          next Size
       fnend
 !
 PARSEFORM: ! Parse Your Form Splitting Out Chunks Into An Array
       def Fnparseform(Mat Chunk$,&Form$;___,Position,Lastposition)
          mat Chunk$(0)
          do While (Position:=Pos(Form$,",",Position+1))
             mat Chunk$(Udim(Mat Chunk$)+1)
             let Chunk$(Udim(Mat Chunk$))=Form$(Lastposition+1:Position)
             let Lastposition:=Position
          loop
       fnend
 !
 STRINGTOGETHER: ! Build String Out Of Array
       def Fnstringtogether$(Mat Chunk$,&String$) ! Pass Byref To Save Workstack
          let String$=""
          for Index=1 to Udim(Mat Chunk$)
             let String$(4096:0)=Chunk$(Index)
          next Index
       fnend
 !
 FIXRPT: ! Function To Fix Repeating Paterns In Form Statements, Thanks To Luis Gomez And Cls
       def Fnfixrpt(&Tf$,&Strip$;___,Rpt_Time) ! Pass Byref To Save Workstack
          let Rpt_Time=Int(Len(Tf$)/Len(Strip$))
          do While Pos(Tf$,","&Strip$)>0
             let Tf$=Srep$(Tf$,","&Rpt$(Strip$,Rpt_Time),","&Str$(Rpt_Time)&"*("&Strip$(1:len(Strip$)-1)&"),")
          loop While (Rpt_Time-=1)>1
       fnend
 !
 ! #Autonumber# 34000,10
  UpdateFile: ! Library call to ensure a file is up to date
  
       def library fnUpdateFile(FileLayout$;___,FileNumber)
          library : fnOpenFile
          dim UpdateForm$(1)*2000
          dim UpdateData$(1)*255
          dim UpdateData(1)

          let FileNumber=fnOpen(FileLayout$,mat UpdateData$,mat UpdateData,mat UpdateForm$,1)
          Close #FileNumber:
       fnend

 READDESCRIPTIONS: ! ***** This Function Returns A String Field From A File Given A Key
       def library Fnreaddescription$*255(Fl,Subscript,Key$*255,Mat F$,Mat F,Mat Fm$;DontChangeKey)
          let fnReadDescription$=fnReadDes$(Fl,Subscript,Key$,mat f$,mat f,mat fm$,DontChangeKey)
       fnend
       def fnReadDes$*255(Fl,Subscript,Key$*255,mat f$,mat f,mat fm$;DontChangeKey)
          mat F$=("") !:
          mat F=(0)
          if ~DontChangeKey then
             let key$=Rpad$(Trim$(Key$)(1:Kln(Fl)),Kln(Fl))
          end if
          read #Fl, using Fm$(Fl), key=key$, release : Mat F$, Mat F nokey IGNORE
          let FnReadDes$=F$(Subscript)
       fnend
 READUNOPENEDDESCRIPTION: ! ***** This function returns a string field from a given key and file
       def library fnReadUnopenedDescription$*255(layoutname$,key$*255;Field,DontChangeKey,___,filenumber)
          dim ReadUnopened$(1)*1000, ReadUnopened(1), ReadUnopenedForm$(1)*1000
          library : fnOpenFile
          if ~Field then let Field=2
          let FileNumber=fnOpen(layoutname$,mat ReadUnopened$,mat ReadUnopened,mat ReadUnopenedForm$,1)
          let fnReadUnopenedDescription$=fnReadDes$(FileNumber,Field,key$,mat ReadUnopened$,mat ReadUnopened,mat ReadUnopenedForm$,DontChangeKey)
          close #FileNumber:
       fnend

 READNUMBER: ! ***** This Function Returns A Numeric Field From A File Given A Key
       def library Fnreadnumber(Fl,Subscript,Key$*255,Mat F$,Mat F,Mat Fm$;DontChangeKey)
          let fnReadNumber=fnReadNum(Fl,Subscript,Key$,Mat f$,mat f,mat fm$,DontChangeKey)
       fnend
 READNUM: ! ***** This Function Returns A Numeric Field From A File Given A Key
       def Fnreadnum(Fl,Subscript,Key$*255,Mat F$,Mat F,Mat Fm$;DontChangeKey)
          mat F$=("") !:
          mat F=(0)
          if ~DontChangeKey then
             let key$=Rpad$(Trim$(Key$)(1:Kln(Fl)),Kln(Fl))
          end if
          read #Fl, using Fm$(Fl), key=key$ : Mat F$, Mat F nokey IGNORE
          let Fnreadnum=F(Subscript)
       fnend
 READUNOPENEDNUMBER: ! ***** This Function Returns A Numeric Field From A File Given A Key
       def library FnreadUnopenedNumber(layoutname$,key$*255;Field,DontChangeKey,___,filenumber)
          library : fnOpenFile
          if ~Field then let Field=1
          let FileNumber=fnOpen(layoutname$,mat ReadUnopened$,mat ReadUnopened,mat ReadUnopenedForm$,1)
          let fnReadUnopenedNumber=fnReadNum(FileNumber,Field,key$,mat ReadUnopened$,mat ReadUnopened,mat ReadUnopenedForm$,DontChangeKey)
          close #FileNumber:
       fnend

 READRelative: ! These functions read a relative file by record number and return a single field
       ! ***** This Function Returns A String Field From A File Given A record
       def library Fnreadrelativedescription$*255(Fl,Subscript,RecordNumber,Mat F$,Mat F,Mat Fm$)
          let fnReadrelativeDescription$=fnReadrelativeDes$(Fl,Subscript,RecordNumber,mat f$,mat f,mat fm$)
       fnend
       def fnReadrelativeDes$*255(Fl,Subscript,RecordNumber,mat f$,mat f,mat fm$)
          mat F$=("") !:
          mat F=(0)
          read #Fl, using Fm$(Fl), rec=RecordNumber, release : Mat F$, Mat F norec IGNORE
          let FnReadrelativeDes$=F$(Subscript)
       fnend
       ! ***** This function returns a string field from a record and file
       def library fnReadRelUnopenedDescription$*255(layoutname$,RecordNumber;Field,___,filenumber)
          library : fnOpenFile
          if ~Field then let Field=2
          let FileNumber=fnOpen(layoutname$,mat ReadUnopened$,mat ReadUnopened,mat ReadUnopenedForm$,1)
          let fnReadRelUnopenedDescription$=fnReadRelativeDes$(FileNumber,Field,RecordNumber,mat ReadUnopened$,mat ReadUnopened,mat ReadUnopenedForm$)
          close #FileNumber:
       fnend

       ! ***** This Function Returns A Numeric Field From A File Given A record
       def library Fnreadrelativenumber(Fl,Subscript,RecordNumber,Mat F$,Mat F,Mat Fm$)
          let Fnreadrelativenumber=fnReadRelativeNum(Fl,Subscript,RecordNumber,mat F$,mat f,mat fm$)
       fnend

       def fnReadRelativeNum(Fl,Subscript,RecordNumber,Mat F$,Mat F,Mat Fm$)
          mat F$=("") !:
          mat F=(0)
          read #Fl, using Fm$(Fl), rec=RecordNumber : Mat F$, Mat F norec IGNORE
          let Fnreadrelativenum=F(Subscript)
       fnend
       
       def library fnReadRelUnopenedNumber(layoutname$,RecordNumber;Field,___,filenumber)
          library : fnOpenFile
          if ~Field then let Field=1
          let FileNumber=fnOpen(layoutname$,mat ReadUnopened$,mat ReadUnopened,mat ReadUnopenedForm$,1)
          let fnReadRelUnopenedNumber=fnReadRelativeNum(FileNumber,Field,RecordNumber,mat ReadUnopened$,mat ReadUnopened,mat ReadUnopenedForm$)
          close #FileNumber:
       fnend

 ReadRecordWhere: ! Search a file for a record based on a filter
       def library fnReadRecordWhere$*255(layoutName$,SearchSub,SearchKey$*255,ReturnSub;___,FileNumber,ReturnValue$*255)
          library : fnOpenFile
          let FileNumber=fnOpen(layoutName$,mat ReadUnopened$,mat ReadUnopened,mat ReadUnopenedForm$,1)
          if FileNumber then
             do while file(filenumber)=0
                read #FileNumber, using ReadUnopenedForm$(FileNumber), release : mat ReadUnopened$,mat ReadUnopened error Ignore
                if File(FileNumber)=0 then
                   if lwrc$(trim$(ReadUnopened$(SearchSub)))=lwrc$(trim$(SearchKey$)) then
                      let ReturnValue$=ReadUnopened$(ReturnSub)(1:255)
                   end if
                end if
             loop until len(trim$(ReturnValue$))
             close #FileNumber:
          end if
          let fnReadRecordWhere$=ReturnValue$
       fnend

 !
 UNIQUEKEY: ! ***** This Function Searches A File To See If A Key Is Unique
       def library Fnuniquekey(Fl,Key$*255)
          restore #Fl, key=Key$: nokey UNIQUEKEYNOTFOUND
          let Fnuniquekey=0 ! False - Key Is Found So Its Not Unique
          goto ENDUNIQUEKEY
 UNIQUEKEYNOTFOUND: ! Key Not Found
          let Fnuniquekey=1 ! True - Key Not Found So It Must Be Unique
 ENDUNIQUEKEY: fnend
 !
 ! #Autonumber# 36000,10
 READALLKEYS: ! ***** Reads A Given String Element (And Optionally A Second Element) From Every Record Of A File Into Given Arrays
       def library Fnreadallkeys(Fl,Mat F$,Mat F,Mat Fm$,Sub1,Mat Out1$;Sub2,Mat Out2$,Index)
          mat Out1$(0)
          if Sub2 then mat Out2$(0)
          restore #Fl:
 NEXTREADALLKEYS: ! Read Next Record
          read #Fl, using Fm$(Fl),release: Mat F$, Mat F eof DONEREADALLKEYS
          mat Out1$(Index:=Udim(Mat Out1$)+1) !:
          let Out1$(Index)=F$(Sub1)
          if Sub2 then !:
             mat Out2$(Index) !:
             let Out2$(Index)=F$(Sub2)
          goto NEXTREADALLKEYS
 DONEREADALLKEYS: ! We Finished Reading Here
       fnend
 !
 ! #Autonumber# 36300,10
 READMATCHINGKEYS: ! ***** Reads A Given String Element (And Optionally A Second Element) From Every Record Of A File Into Given Arrays Only When Key Element Matches Specified Key. Key Must Match Specified Element Key.
       def library Fnreadmatchingkeys(Fl,Mat F$,Mat F,Mat Fm$,Key$,Keyfld,Sub1,Mat Out1$;Sub2,Mat Out2$,Index)
          mat Out1$(0)
          if Sub2 then mat Out2$(0)
          restore #Fl, key=Key$: nokey DONEREADMATCHINGKEYS
 NEXTREADMATCHINGKEYS: ! Read Next Record
          read #Fl, using Fm$(Fl),release: Mat F$, Mat F eof IGNORE
          if (File(Fl)=10) Or (F$(Keyfld)<>Key$) then goto DONEREADMATCHINGKEYS
          mat Out1$(Index:=Udim(Mat Out1$)+1) !:
          let Out1$(Index)=F$(Sub1)
          if Sub2 then !:
             mat Out2$(Index) !:
             let Out2$(Index)=F$(Sub2)
          goto NEXTREADMATCHINGKEYS
 DONEREADMATCHINGKEYS: ! We Finished Reading Here
       fnend
 !
 ! #Autonumber# 36600,10
 READALLNEWKEYS: ! ***** This Version Of Our Popular Fileio Library Function Reads Only New Items Into The Array.
       def library Fnreadallnewkeys(Fl,Mat F$,Mat F,Mat Fm$,Sub1,Mat Out1$;Dont_Reset,Sub2,Mat Out2$,Index)
          if ~Dont_Reset then mat Out1$(0)
          if (~Dont_Reset) And (Sub2) then mat Out2$(0)
          restore #Fl:
 NEXTREADALLNEWKEYS: ! Read Next Record
          read #Fl, using Fm$(Fl),release: Mat F$, Mat F eof DONEREADALLNEWKEYS
          if Srch(Mat Out1$,F$(Sub1))<1 then ! If Not Found Then
             mat Out1$(Index:=Udim(Mat Out1$)+1) !:
             let Out1$(Index)=F$(Sub1)
             if Sub2 then !:
                mat Out2$(Index) !:
                let Out2$(Index)=F$(Sub2)
          end if
          goto NEXTREADALLNEWKEYS
 DONEREADALLNEWKEYS: ! We Finished Reading Here
       fnend
 !
 ! #Autonumber# 37000,10
 READFILTERKEYS: ! ***** Read Matching Keys, But It Also Supports Optional Filters And Up To Four Arrays May Be Populated At Once. If Readlarger=True Then Read All Larger Keys. Function By Mikhail Zheleznov
       def library Fnreadfilterkeys(Fl,Mat F$,Mat F,Mat Fm$,Key$,Keyfld,Sub1,Mat Out1$;Filter$,Filter_Sub,Readlarger,Sub2,Mat Out2$, Sub3, Mat Out3$, Sub4,Mat Out4$, Index)
          mat Out1$(0)
          if Sub2 then mat Out2$(0)
          if Sub3 then mat Out3$(0)
          if Sub4 then mat Out4$(0)
          restore #Fl, key=Key$: nokey DONEREADFILTERKEYS
 NEXTREADFILTERKEYS: ! Read Next Record
          read #Fl, using Fm$(Fl),release: Mat F$, Mat F eof IGNORE
          if (File(Fl)=10) Or (~Readlarger And (F$(Keyfld)<>Key$)) Or (Readlarger And (F$(Keyfld)<Key$)) then goto DONEREADFILTERKEYS
          if (Filter$ ~= "" And F$(Filter_Sub) ~= Filter$) then goto NEXTREADFILTERKEYS
          mat Out1$(Index:=Udim(Mat Out1$)+1) !:
          let Out1$(Index)=F$(Sub1)
          if Sub2 then !:
             mat Out2$(Index) !:
             let Out2$(Index)=F$(Sub2)
          if Sub3 then !:
             mat Out3$(Index) !:
             let Out3$(Index)=F$(Sub3)
          if Sub4 then !:
             mat Out4$(Index) !:
             let Out4$(Index)=F$(Sub4)
          goto NEXTREADFILTERKEYS
 DONEREADFILTERKEYS: ! We Finished Reading Here
       fnend
 !
 ! #Autonumber# 38000,10
 MAKEUNIQUEKEYS: ! ***** Builds A Unique Key For Given File Of Kylen Length
    def library Fnmakeuniquekey$*255(Fl;Index)
       library : Fnuniquekey
       dim Mukindexs(1)
       mat Mukindexs(Kln(Fl))=(0)
       do While Not Fnuniquekey(Fl,Fnbuildkeyforunique$(Mat Mukindexs))
          let Mukindexs(1)+=1
          for Index=1 to Udim(Mukindexs)-1
             if Mukindexs(Index)>35 then let Mukindexs(Index)=0 : let Mukindexs(Index+1)+=1
          next Index
          if Mukindexs(Udim(Mukindexs))>35 then let Msgbox("The system cannot sustain more then "&Str$(35**Udim(Mukindexs))&" of these. Please delete old ones and try again.")
       loop Until Mukindexs(Udim(Mukindexs))>35
       let Fnmakeuniquekey$=Fnbuildkeyforunique$(Mat Mukindexs)
    fnend
 !
 ! #Autonumber# 38500,10
 BUILDKEYFORUNIQUES: ! Builds A Key Out Of The Byte Matrix Given
    def Fnbuildkeyforunique$*255(Mat Bkfuindexs;Index,Key$*255)
       for Index=Udim(Bkfuindexs) to 1 step -1
          if bkfuindexs(Index)<10 then
             let Key$=Key$&str$(bkfuIndexs(Index))
          else
             let Key$=Key$&Chr$(Bkfuindexs(Index)+55)
          end if
       next Index
       let Fnbuildkeyforunique$=Key$
    fnend
 !
 ! #Autonumber# 39000,10
 SEARCHCLOSELY: ! ***** Searches Mat A$ Looking For A Partial Match To B$
       def Fnsearchclosely(Mat A$,B$;Index,Found)
          for Index=1 to Udim(Mat A$)
             if Pos(A$(Index),B$) then let Found=Index
          next Index
          let Fnsearchclosely=Found
       fnend
 !
 ! #Autonumber# 40000,10
 LOG: ! ***** Log An Entry
       def library Fnlog(String$*255;Filehandle)
          library : Fngetfilenumber
          open #(Filehandle:=Fngetfilenumber) : "Name=FileIO.log, use",display,output
          print #Filehandle: "Computer: "&Login_Name$&" - WSID: "&Session$&" - Date: "&Date$("mm/dd/ccyy")&" - "&Time$("hh:mm:ss")&": "&String$
          close #Filehandle:
       fnend
 !
 ! #Autonumber# 40500,10
 ERRLOG: ! ***** Log An Error Entry
       def library Fnerrlog(String$*255;Filehandle)
          library : Fngetfilenumber
          open #(Filehandle:=Fngetfilenumber) : "Name=FileIO.log, use",display,output
          print #Filehandle: "Error("&Str$(Err)&":"&Str$(Line)&")"& "Computer: "&Login_Name$&" - WSID: "&Session$&" - "&Date$("mm/dd/ccyy")&" - "&Time$("hh:mm:ss")&": "&String$
          close #Filehandle:
       fnend
 !
 ! #Autonumber# 42000,10
 NOTINFILE: ! ***** Search A Given Spot In A File For A Given String, Return True If Not Found
       def library Fnnotinfile(String$*100,Filename$,Sub;Path$,Filenumber)
          library : Fnopenfile,Fnreadallkeys
          dim F$(1)*255,F(1),Fmmm$(1)*2000,Filelist$(1)*255
          let Filenumber=Fnopen(Filename$,Mat F$,Mat F,Mat Fmmm$,1,0,0,Path$)
          let Fnreadallkeys(Filenumber,Mat F$,Mat F,Mat Fmmm$,Sub,Mat Filelist$)
          if Fnsearchclosely(Mat Filelist$,String$)=0 then let Fnnotinfile=1
          close #Filenumber: !:
       fnend

 GetFileDateTime: ! Performs a directory listing to get the date of a file
       def fnGetFileDateTime$(FileName$*255;___,DirFile,Dummy$*255)
          library : Fngetfilenumber
          execute "dir "&FileName$&" >xxx[WSID]"
          open #(Dirfile:=Fngetfilenumber) : "Name=xxx[WSID]", display,input
          do
             linput #Dirfile: Dummy$ eof Ignore
             if file(DirFile)=0 then
                if lwrc$(trim$(Dummy$(46:99)))=lwrc$(trim$(FileName$(pos(FileName$,"\",-1)+1:len(FileName$)))) then
                   let fnGetFileDateTime$=Dummy$(27:42)
                end if
             end if
          loop while file(DirFile)=0
          close #Dirfile:
          let ErrorRetrycount=0
          execute "*free xxx[WSID] -n" error RetryCount
       fnend
 !
 ! #Autonumber# 43000,10
 READLAYOUTS: ! ***** Reads Into A Given Array The List Of File Layouts
       def library Fnreadlayouts(Mat Dirlist$;___,Dummy$*255,Dirfile,Layoutpath$*255)
          library : Fngetfilenumber
          let Fnsettings(Layoutpath$)
          mat Dirlist$(0)
          execute "dir "&Layoutpath$&" >xxx"
          open #(Dirfile:=Fngetfilenumber) : "Name=xxx", display,input
 READFILENAME: ! Read The Next File Name
          linput #Dirfile: Dummy$ eof DONEREADINGFILENAMES
          if Dummy$(11:13)="   " And ~Pos(Dummy$,"<DIR>") then
             mat Dirlist$(Udim(Dirlist$)+1) !:
             let Dirlist$(Udim(Dirlist$))=Trim$(Dummy$(44:99))(1:30)
          end if
          goto READFILENAME
 DONEREADINGFILENAMES: ! Finished
          close #Dirfile:
          execute "*free xxx"
       fnend
 !
 DOESLAYOUTEXIST: ! Return True If Layout Exists In The Layouts Folder
       def library Fndoeslayoutexist(Layout$;Layoutpath$*255)
          let Fnsettings(Layoutpath$)
          if trim$(layout$)<>"" then
             let Fndoeslayoutexist = Exists(Layoutpath$&Layout$)
          end if
       fnend
 !
 ! #Autonumber# 44000,10
 MESSAGEBOX: ! ***** Displays A Message Box In New Or Old Gui
       def Fnmessagebox(Message$*60;Title$*20,_Window,_Choice,_Kp$)
          library : Fngetfilenumber
          if Trim$(Env$("guimode"))="" then ! Old Gui Version
             open #(_Window:=Fngetfilenumber): "SROW=10,SCOL=10,EROW=14,ECOL=69,Border=S,Caption="&Title$,display,outin
             print #_Window: Newpage
             print #_Window, fields "2,1,CC 60" : Message$
             print #_Window, fields "4,1,CR 29" : "Answer (Y/N):"
             do
                rinput #_Window, fields "4,31,C 1" : _Kp$
             loop Until (Fkey=0 And (Uprc$(_Kp$)="Y" Or Uprc$(_Kp$)="N")) Or Fkey=99
             if Fkey=0 And Uprc$(_Kp$)="Y" then let Fnmessagebox=1 else let Fnmessagebox=0
             close #_Window:
          else ! New Gui Version
             let _Choice=Msgbox(Message$,Title$,"okC")
             if _Choice=1 then let Fnmessagebox=1 else let Fnmessagebox=0
          end if
       fnend
 !
 KEY: ! ***** This Function Calculates The Key For A File
       def library Fnkey$*255(Filenumber, Key$*255)
          let Fnkey$=Rpad$(Key$,Kln(Filenumber))
       fnend

 !
 ! #Autonumber# 60000,10
 VALIDATEROWCOL: !
       def fnvalidatenonguirowcol(&srow$,&scol$,&rows$,&cols$;___,dummy,Rows,Cols)

          let Dummy=0
          let Dummy=val(srow$) conv Ignore
          let srow$=str$(Dummy)
          
          let Dummy=0
          let Dummy=val(scol$) conv Ignore
          let scol$=str$(Dummy)
          
          let Dummy=0
          let Dummy=val(rows$) conv Ignore
          let rows$=str$(Dummy)
          
          let Dummy=0
          let Dummy=val(cols$) conv Ignore
          let cols$=str$(Dummy) conv Ignore

          if val(srow$)<2 or val(srow$)>24 then let srow$="2"
          if val(scol$)<2 or val(scol$)>78 then let scol$="2"

          let fnReadScreenSize(Rows,Cols)

          if val(rows$)<1 then let rows$=str$(rows-2)
          if val(cols$)<1 then let cols$=str$(cols-2)
 !         if val(rows$) - val(srow$) > 24 then let rows$=str$(24-val(srow$))
 !         if val(cols$) - val(scol$) > 80 then let cols$=str$(80-val(scol$))
       fnend

 READSCREENSIZE: ! Return The Screen Size Of Window 0 In Terms Of Rows And Columns
    def Fnreadscreensize(&Rows,&Cols;___,Ffile,String$*2000,Srow,Scol,Erow,Ecol,Position)
 !
       execute "Status Files >[WSID].tmp"
       open #(Ffile:=Fngetfilenumber) : "name=[WSID].tmp",display,input
 !
       do While File(Ffile)=0
          linput #Ffile: String$ eof IGNORE
       loop Until String$(1:5)="-----"
       do While File(Ffile)=0
          linput #Ffile: String$ eof IGNORE
       loop Until (Lwrc$(String$)(1:4)="open") And Trim$(String$(Pos(String$,"#")+1:Pos(String$,"#")+5))="0"
       if File(Ffile)=0 then
          linput #Ffile: String$ eof IGNORE
       end if
 !
       close #Ffile:
       execute "*Free [WSID].tmp"
 !
       if (Position:=Pos(Uprc$(String$),"SROW=")) then
          let Srow=Val(String$(Position+5:Pos(String$,",",Position)-1)) conv IGNORE
       end if
       if (Position:=Pos(Uprc$(String$),"SCOL=")) then
          let Scol=Val(String$(Position+5:Pos(String$,",",Position)-1)) conv IGNORE
       end if
       if (Position:=Pos(Uprc$(String$),"EROW=")) then
          let Erow=Val(String$(Position+5:Pos(String$,",",Position)-1)) conv IGNORE
       end if
       if (Position:=Pos(Uprc$(String$),"ECOL=")) then
          let Ecol=Val(String$(Position+5:Pos(String$,",",Position)-1)) conv IGNORE
       end if
       if Srow And Erow then let Rows=Erow-Srow+1
       if Scol And Ecol then let Cols=Ecol-Scol+1
 !
    fnend
    def fn42=(val(wbversion$(1:3))>=4.2)
!
 ! #Autonumber# 99000,10
 OPEN: ! ***** Function To Call Library Openfile And Proc Subs
       def Fnopen(Filename$*255, Mat F$, Mat F, Mat Form$; Inputonly, Keynum, Dont_Sort_Subs, Path$*255, Mat Descr$, Mat Field_Widths,Supress_Prompt,___,Index)
          dim _FileIOSubs$(1)*800
          let Fnopen=Fnopenfile(Filename$, Mat F$, Mat F, Mat Form$, Inputonly, Keynum, Dont_Sort_Subs, Path$, Mat Descr$, Mat Field_Widths, Mat _FileIOSubs$, Supress_Prompt)
          for Index=1 to udim(mat _FileIOSubs$) : execute (_FileIOSubs$(Index)) : next Index
       fnend
 !
 ! #Autonumber# 99900,10
 IGNORE: continue
 RetryCount: !
    if ErrorRetryCount<5 then
       let ErrorRetryCount+=1
       retry
    else
       let ErrorRetryCount=0
       continue
    end if